package monnethic.mobile.search;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import com.example.monnthic.monnethicmobile.R;
import java.util.ArrayList;
import monnethic.mobile.restApi.SessionApiHandler;

public class DisplayWalletSearch extends AppCompatActivity {
    private ArrayList<DisplayWallet> displayWallets;
    private String session_id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_display_wallet_search);

        ListView listView = (ListView) findViewById(R.id.listViewWalletSearch);
        Intent intent = getIntent();
        session_id = intent.getStringExtra("SESSION_ID");

        try {
            displayWallets = (ArrayList<DisplayWallet>) intent.getSerializableExtra("data");
        } catch (Exception e){
            e.printStackTrace();
        }

        DisplayWalletAdapter adapter = new DisplayWalletAdapter(this,displayWallets);
        listView.setAdapter(adapter);

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                DisplayWallet dW = (DisplayWallet) listView.getItemAtPosition(i);
                Intent intent1 = new Intent();
                intent1.putExtra("walletHash",dW.getWallet_hash());
                setResult(1,intent1);
                finish();
            }
        });
    }

    @Override
    protected void onStop() {
        super.onStop();  // Always call the superclass method first
        new EndSessionTask().execute(session_id);
    }

    private class EndSessionTask extends AsyncTask<String,Void,Void> {
        @Override
        protected Void doInBackground(String... strings) {
            try{
                SessionApiHandler sessionApiHandler = new SessionApiHandler();
                sessionApiHandler.endSession(strings[0]);
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }
    }

}
